Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1374)
@@ -37,6 +37,4 @@
       Debug("Message probing for intracomm\n");
       
-
-      //#ifdef _openmpi
       #pragma omp critical (_mpi_call)
       {
@@ -51,17 +49,5 @@
         }
       }
-      //#elif _intelmpi
-      //#pragma omp critical (_mpi_call)
-      //{
-      //  ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm.mpi_comm), &flag, &status);
-      //  if(flag)
-      //  {
-      //    Debug("find message in mpi comm \n");
-      //    mpi_source = status.MPI_SOURCE;
-      //    int tag = status.MPI_TAG;
-      //    ::MPI_Mprobe(mpi_source, tag, to_mpi_comm(comm.mpi_comm), &message, &status);
-      //  }
-      //}
-      //#endif
+
       
       if(flag)
@@ -90,5 +76,5 @@
         }
         
-        delete msg_block;        
+        delete msg_block;
       }
 
@@ -117,5 +103,4 @@
       Debug("Message probing for intracomm\n");
 
-      //#ifdef _openmpi
       #pragma omp critical (_mpi_call)
       {
@@ -170,5 +155,4 @@
       Debug("Message probing for intracomm\n");
      
-      //#ifdef _openmpi
       #pragma omp critical (_mpi_call)
       {
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1374)
@@ -101,7 +101,5 @@
 
     ::MPI_Request mpi_request;
-    //::MPI_Message mpi_message = *(static_cast< ::MPI_Message* >(message->mpi_message));
     ::MPI_Imrecv(buf, count, to_mpi_type(datatype), static_cast< ::MPI_Message* >(message->mpi_message), &mpi_request);		
-    //::MPI_Imrecv(buf, count, to_mpi_type(datatype), &mpi_message, &mpi_request);
 
     request->mpi_request = new ::MPI_Request(mpi_request);
@@ -121,7 +119,5 @@
 
     ::MPI_Status mpi_status;
-    //::MPI_Message mpi_message = *(static_cast< ::MPI_Message* >(message->mpi_message));
     ::MPI_Mrecv(buf, count, to_mpi_type(datatype), static_cast< ::MPI_Message* >(message->mpi_message), &mpi_status);
-    //::MPI_Mrecv(buf, count, to_mpi_type(datatype), &mpi_message, &mpi_status);
 
     status->mpi_status = new ::MPI_Status(mpi_status);
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1374)
@@ -25,5 +25,5 @@
     {
       ::MPI_Status mpi_status;
-      ::MPI_Test((request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(static_cast< ::MPI_Request*>(request->mpi_request), flag, &mpi_status);
       
       if(*flag) 
@@ -50,5 +50,5 @@
       ::MPI_Status mpi_status;
       
-      ::MPI_Test((request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(static_cast< ::MPI_Request*>(request->mpi_request), flag, &mpi_status);
       
       
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1374)
@@ -67,23 +67,8 @@
   }
   
-  MPI_Request::MPI_Request(int* request)
+  MPI_Request::MPI_Request(void* request)
   {
-    //mpi_request = request;
-    mpi_request = new int;
-    *mpi_request = *request;
-  }
-  
-//  MPI_Request::MPI_Request(void* request)
-//  {
-//    //mpi_request = request;
-//    mpi_request = new int;
-//    static_cast< ::MPI_Request>(*mpi_request) = *(static_cast< ::MPI_Request*>(request);
-//  }
-  
-  MPI_Request::MPI_Request()
-  {
-    //mpi_request = request;
-    mpi_request = new int;
-    //*(static_cast< ::MPI_Request*>(mpi_request)) = *(static_cast< ::MPI_Request*>(request));
+    mpi_request = new ::MPI_Request;
+    *(static_cast< ::MPI_Request*>(mpi_request)) = *static_cast< ::MPI_Request*>(request);
   }
   
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1374)
@@ -230,5 +230,5 @@
     public:
 
-      int* mpi_request;
+      void* mpi_request;
 
       int type;	//! type of the non-blocking communication. 1: Isend; 2:Irecv; 3:Imrecv; 4:Issend
@@ -241,6 +241,6 @@
       MPI_Comm comm;	//! EP communicator related to the communication
 
-      MPI_Request();
-      MPI_Request(int* request);
+      MPI_Request() {}
+      MPI_Request(void* request);
       bool operator == (MPI_Request right);
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1374)
@@ -34,5 +34,5 @@
     //::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
     ::MPI_Status mpi_status;
-    ::MPI_Wait((request->mpi_request), &mpi_status);
+    ::MPI_Wait(static_cast< ::MPI_Request*>(request->mpi_request), &mpi_status);
 
    
@@ -81,5 +81,5 @@
           finished.at(i) = 1;
           //mpi_request[i] = static_cast< ::MPI_Request >(array_of_requests[i].mpi_request);
-          mpi_request[i] = *(array_of_requests[i].mpi_request);
+          mpi_request[i] = *static_cast< ::MPI_Request*>(array_of_requests[i].mpi_request);
         }
       }    
Index: /XIOS/dev/branch_openmp/src/client.cpp
===================================================================
--- /XIOS/dev/branch_openmp/src/client.cpp	(revision 1373)
+++ /XIOS/dev/branch_openmp/src/client.cpp	(revision 1374)
@@ -188,6 +188,5 @@
 
         MPI_Send((void*)buff,buffer.count(),MPI_CHAR,serverLeader,1,CXios::globalComm) ;
-        #pragma omp critical (_output)
-        std::cout<<"client "<<rank<<" send to server "<<serverLeader << buffer.count() <<"message with tag 1" << std::endl;
+
         delete [] buff ;
 